#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define MSIZE 250
void main(void) {
	pid_t pid;
	int fd[2];
	int i=0;
	int status;
	FILE *fp;
	char mesg_s[MSIZE];
	char mesg[MSIZE];
	memset(mesg,'\0',MSIZE);
	memset(mesg_s,'\0',MSIZE);
	fp=fopen("pipe_message.txt","w");
 while (1) {
	pipe(fd);
	pid=fork();
	if (pid==0) {
	/*Inside Child*/
		printf("[%d]Child start\n",getpid());
		close(fd[0]);
		printf("[%d]Give me Message:",getpid());
		fgets(mesg,MSIZE,stdin);
		while (mesg[i]!='\n') i++;
        	mesg[i]='\0';
		write(fd[1],mesg,strlen(mesg)+1);
		memset(mesg,'\0',MSIZE);
		printf("[%d]Child end\n",getpid());
		exit(0);
	} else {
	/*Inside Parent*/
		printf("[%d]Parent start\n",getpid());
		close(fd[1]);
		while (read(fd[0],mesg_s, MSIZE) > 0)
  		{	
			printf("[%d]Message:%s received\n",getpid(),mesg_s);	
    			fprintf(fp,"%s\n", mesg_s);
			fflush(fp);
			memset(mesg_s,'\0',MSIZE);
                        printf("[%d]Wait for child pid [%d] to finish\n",getpid(),pid);
			
			while((pid=waitpid(pid,&status,0))>0)
			{
				printf("[%d]Child pid [%d] exited normally with status %d\n",pid,WEXITSTATUS(status));
			}
  		}
		printf("[%d]Parent - Loop - Restart\n",getpid());
 	   } 
	}
}	

